public:
    // ISpringProxActiveXCtl 
	STDMETHOD(get_LastError) (SHORT* pVal);
	STDMETHOD(get_LastErrorTxt) (BSTR* pVal);

	STDMETHOD(get_Library) (BSTR* pVal);
	STDMETHOD(get_Firmware) (BSTR* pVal);
	STDMETHOD(get_Device) (BSTR* pVal);
	STDMETHOD(put_Device) (BSTR newVal);
	STDMETHOD(get_Active) (BYTE* pVal);
 	STDMETHOD(put_Active) (BYTE newVal);
	STDMETHOD(Open)  (void);
	STDMETHOD(Close) (void);

  STDMETHOD(put_RfField) (BYTE newVal);
  STDMETHOD(put_LedRed) (BYTE newVal);
  STDMETHOD(put_LedGreen) (BYTE newVal);
  STDMETHOD(put_LedYellow) (BYTE newVal);
  STDMETHOD(put_IsoConfig) (BYTE newVal);
  STDMETHOD(get_IsoConfig) (BYTE* pVal);

	STDMETHOD(TagSelect) (void);
	STDMETHOD(SelectAny) (void);
	STDMETHOD(SelectIdle) (void);
	STDMETHOD(SelectAgain) (void);
	STDMETHOD(TagHalt) (void);
	STDMETHOD(Halt) (void);
	
	STDMETHOD(get_TagSnr) (BSTR* pVal);
	STDMETHOD(get_TagAtq) (BSTR* pVal);
	STDMETHOD(get_TagSak) (BSTR* pVal);

	STDMETHOD(get_Uid) (BSTR* pVal);
	STDMETHOD(get_Pupi) (BSTR* pVal);
	STDMETHOD(get_Atq) (BSTR* pVal);
	STDMETHOD(get_Sak) (BSTR* pVal);

  STDMETHOD(put_Cid) (BYTE newVal);
  STDMETHOD(get_Cid) (BYTE* pVal);
  STDMETHOD(put_Nad) (BYTE newVal);
  STDMETHOD(get_Nad) (BYTE* pVal);

	STDMETHOD(get_TclAts) (BSTR* pVal);
	STDMETHOD(get_Ats) (BSTR* pVal);

	STDMETHOD(TclSelect)(void);
	STDMETHOD(TclDeselect)(void);
	
	STDMETHOD(get_TclData)(BSTR* pVal);
	STDMETHOD(put_TclData)(BSTR newVal);
  STDMETHOD(get_TclDataSW) (LONG* pVal);
	STDMETHOD(TclExchange)(void);

  STDMETHOD(ReadPage)  (BYTE pageAddr);	
	STDMETHOD(WritePage) (BYTE pageAddr);	
  STDMETHOD(ReadBlock)  (BYTE blockAddr);	
	STDMETHOD(WriteBlock) (BYTE blockAddr);	
	STDMETHOD(ReadSector) (BYTE sector);
	STDMETHOD(WriteSector)(BYTE sector);
	STDMETHOD(FormatSector) (BYTE sector, BSTR keyA, BSTR keyB, BYTE ac0, BYTE ac1, BYTE ac2);
	STDMETHOD(WriteSectorTrailer) (BYTE sector, BSTR keyA, BSTR keyB, BYTE ac0, BYTE ac1, BYTE ac2);
	STDMETHOD(get_LastAuthKey) (BSTR* pVal);
	STDMETHOD(put_MifKeyRead) (BSTR newVal);
	STDMETHOD(put_MifKeyWrite) (BSTR newVal);
	STDMETHOD(LoadKey)(BOOL E2, BOOL B, BYTE index, BSTR newVal);	

	STDMETHOD(get_PageData) (BSTR* pVal);
 	STDMETHOD(put_PageData) (BSTR newVal);
	STDMETHOD(get_PageDataTxt) (BSTR* pVal);
	STDMETHOD(put_PageDataTxt) (BSTR newVal);
	STDMETHOD(get_BlockData) (BSTR* pVal);
 	STDMETHOD(put_BlockData) (BSTR newVal);
	STDMETHOD(get_BlockDataTxt) (BSTR* pVal);
	STDMETHOD(put_BlockDataTxt) (BSTR newVal);
	STDMETHOD(get_SectorData) (BSTR* pVal);
	STDMETHOD(put_SectorData) (BSTR newVal);
	STDMETHOD(get_SectorDataTxt) (BSTR* pVal);
//	STDMETHOD(put_SectorDataTxt) (BSTR newVal);

private:
	BOOL Active;
	BYTE IsoConfig;

  BYTE Cid;
  BYTE Nad;

  BYTE LedR;
  BYTE LedG;
  BYTE LedY;

  wchar_t DeviceName[24];

	BYTE IsoASnr[12];
	BYTE IsoASnrLen;
	BYTE IsoAAtq[2];
	BYTE IsoASak[1];
  BYTE IsoAAts[32];
	BYTE IsoAAtsLen;

	BYTE IsoBAtq[11];

	BYTE MifKeyRead[6];
  BOOL MifKeyReadLoaded;
	BYTE MifKeyWrite[6];
  BOOL MifKeyWriteLoaded;

	BYTE MifULPageData[4];
	BYTE MifULPageDataOK;
	BYTE MifBlockData[16];
	BYTE MifBlockDataOK;
	BYTE MifSectorData[240];
  BYTE MifSectorDataOK;

	BYTE TclDataSend[256+6];
	WORD TclDataSendLen;
	BYTE TclDataRecv[256];
	WORD TclDataRecvLen;

	short LastError;

  void toBSTR(BSTR *dst, const wchar_t *src);
  void fromBSTR(wchar_t *dst, const BSTR src);

  BOOL isHEX(const wchar_t *src);
  void toHEX(wchar_t *dst, const BYTE *src, size_t sz);
  void fromHEX(BYTE *dst, const wchar_t *src, size_t max_sz, size_t *act_sz);
 
  BOOL getKey(BYTE *dst, BSTR src);
