#include "sagem_mso_i.h"

MSO_STATUS MSO_GetDescriptor(BYTE *desc, WORD desc_len)
{
  BYTE    send_get[] = { 0x05, 0x01, 0x00, 0x2F };
  BYTE    buffer[512];
  WORD    size = sizeof(buffer);
  WORD    offset, length;
  BYTE   *value;
  BYTE    tag;
  WORD    i, j;
  MSO_STATUS rc;

  rc = MSO_Exchange(send_get, sizeof(send_get), buffer, &size, 1000);
  if ((rc != ILV_OK) || (desc == NULL))
    return rc;

  memset(desc, 0, desc_len);
  i = 0;

  offset = 4;
  while ((offset < size) && (MSO_ILV_Loop(buffer, &offset, &tag, &length, &value)))
  {
    watchdog_update();
    switch (tag)
    {
      case ID_DESC_PRODUCT:
        if (i < desc_len - 6)
        {
          strcpy(&desc[i], "Hard: ");
          i += 6;
        }
        break;
      case ID_DESC_SOFTWARE:
        if (i < desc_len - 6)
        {
          strcpy(&desc[i], "Soft: ");
          i += 6;
        }
        break;
      case ID_DESC_SENSOR:
        if (i < desc_len - 6)
        {
          strcpy(&desc[i], "Sens: ");
          i += 6;
        }
        break;
      default:
        break;
    }

    for (j = 0; j < length; j++)
    {
      if (i < desc_len)
      {
        switch (value[j])
        {
          case '\0':
          case '\r':
          case '\n':
            if (desc[i - 1] != ',')
              desc[i++] = ',';
            break;
          case '\t':
          case ' ':
            if (desc[i - 1] != ' ')
              desc[i++] = ' ';
            break;
          default:
            desc[i++] = value[j];
        }
      }
    }

    while ((i >= 0) && (desc[i] <= ' '))
      i--;
    i++;

    if (i < desc_len)
      desc[i++] = '\0';
  }
/*
  desc_len = i;
  PrintCRLF();
  for (i=0; i<desc_len; i++)
  {
    PrintChr(desc[i]);
    watchdog_update();
  }
  PrintCRLF();
  for (i=0; i<desc_len; i++)
  {
    PrintHex(desc[i]);
    watchdog_update();
  }
  PrintCRLF();
*/
  return ILV_OK;
}
